/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace Correlator
{
    /// <summary>
    /// Interaction logic for ActionList.xaml
    /// </summary>
    public partial class ActionList : UserControl
    {
        public ActionList()
        {
            InitializeComponent();
        }

        Point startPoint;

        #region DragDrop
        private void list_PreviewMouseMove(object sender, MouseEventArgs e)
        {
                // Get the current mouse position
                Point mousePos = e.GetPosition(null);
                Vector diff = startPoint - mousePos;

                if (e.LeftButton == MouseButtonState.Pressed &&
                    (Math.Abs(diff.X) > SystemParameters.MinimumHorizontalDragDistance ||
                    Math.Abs(diff.Y) > SystemParameters.MinimumVerticalDragDistance))
                {

                    // Find the data behind the ListViewItem
                    var action = (MicroAction)list.SelectedValue;
                    if (action != null)
                    {
                        // Initialize the drag & drop operation
                        DataObject dragData = new DataObject("Action", action);
                        DragDrop.DoDragDrop(list, dragData, DragDropEffects.Move);
                    }
                }
        }

        private void list_DragLeave(object sender, DragEventArgs e)
        {
            if (!e.Data.GetDataPresent("Action"))
            {
                e.Effects = DragDropEffects.None;
            }
        }
 
        private void list_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            startPoint = e.GetPosition(null);
        }
        #endregion


    }
}


