/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;

namespace Correlator
{
    public class ColoredAction
    {
        public Action action { get; set; }

        public string name { get { return action.name; } }

        public List<ColoredArgument> args { get; private set; }

        public ColoredAction(Action action)
        {
            this.action = action;
            this.args = action.args.Select(z => new ColoredArgument(z,null,Colors.Get())).ToList();
        }

        public ColoredAction(string name)
        {
            action = new MacroAction(name);
        }

    }
}


