/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;

namespace Correlator
{
    public class ColoredArgument
    {
        public Argument argument { get; protected set; }
        public string type { get { return argument.type.name; } }
        public string title { get { return argument.title; } }

        public List<string> constants
        {
            get
            {
                return argument.type.constants;
            }
        }

        public object binding { get; private set; }

        public ColoredArgument(Argument argument,object binding, SolidColorBrush color)
        {
            this.color = color;
            this.binding = binding;
            this.argument = argument;
        }

        public ColoredArgument(Argument argument)
        {
            this.argument = argument;
            color = Brushes.Red;
        }

        public SolidColorBrush color { get; set; }
    }
}


