/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;

namespace Correlator
{
    public class ColoredUAction
    {
        public bool primary
        {
            get { return uaction.primary; }
            set { uaction.primary = value; }
        }

        public UAction uaction { get; private set; }

        public string name { get { return uaction.action.name; } }

        public IEnumerable<ColoredArgument> args { get; private set; }

        public ColoredUAction(MicroAction action)
        {
            this.uaction = new UAction(action);
            this.args = this.uaction.action.args.Select(z => new ColoredArgument(z));
        }

        public ColoredUAction(ColoredAction macro, UAction micro)
        {
            this.uaction = micro;
            int tester = 0;
            this.args = micro.boundArguments.Select(z => new ColoredArgument(z.argument, z.binding,
                z.bound ?
                    int.TryParse(z.binding.ToString(), out tester) ?
                        macro.args[int.Parse(z.binding.ToString())].color
                        : Brushes.LightGreen
                    : Brushes.Red));
        }
    }
}


