/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;

namespace Correlator
{
    public static class Colors
    {
        static Queue<SolidColorBrush> queue;
        public static SolidColorBrush Get()
        {
            if (queue == null)
                queue = colors;
            var color = queue.Dequeue();
            queue.Enqueue(color);
            return color;
        }
        static Queue<SolidColorBrush> colors
        {
            get
            {
                return new Queue<SolidColorBrush>(new List<SolidColorBrush>()
                {
                    Brushes.Green,
                    Brushes.Purple,
                    Brushes.Pink,
                    Brushes.Yellow,
                    Brushes.SkyBlue,
                    Brushes.Magenta,
                    Brushes.Cyan,
                    Brushes.Crimson,
                    Brushes.Aqua,
                    Brushes.SlateGray,
                    Brushes.Violet,
                    Brushes.Orange,
                    Brushes.Brown,
                    Brushes.LightPink,
                    Brushes.LightYellow,
                    Brushes.LightBlue,
                    Brushes.LightSteelBlue,
                    Brushes.LightSeaGreen
                });
            }
        }

        internal static bool Contains(SolidColorBrush background)
        {
            return colors.Contains(background);
        }
    }
}


