/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;

namespace ExperienceManager
{
    public class InitialState
    {
        string path = @"\initial.txt";
        public InitialState()
        {
            var local = new FileInfo(new Uri(Assembly.GetEntryAssembly().GetName().CodeBase).AbsolutePath).Directory.FullName.Replace("%20", " ");
            path = local + path;
        }

        public List<string> Get()
        {
            if (File.Exists(path))
                return File.ReadAllLines(path).Where(z => z != string.Empty && z.Length > 0).ToList() ;
            return null;
        }
    }
}


