/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;

namespace ExperienceManager
{
    internal class InputProcessor:Processor
    {
        public InputProcessor(ProcessCore core) : base(core) { }
        public delegate void Received(string action);
        public event Received OnInput;

        protected override void Process(Message message)
        {
            if(message is InputMessage)
            {
                OnInput?.Invoke(message.action);
            }
        }

        protected override void Completed()
        {
        }
    }
}

