/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExperienceManager
{
    public class ProcessCore
    {
        public delegate void OnReceive(Message message);
        public event OnReceive OnNewMessage;
        public void Process()
        {
            string msg;
            while ((msg = Console.ReadLine()) != null)
            {
                if (msg.Equals("input Reset"))
                    Program.Reset();
                if (msg.ToLower().Equals("started walking") || msg.ToLower().Equals("stopped walking") || msg.IndexOf(' ')==-1)
                    continue;
                Message message;
                switch (msg.Substring(0,msg.IndexOf(' ')))
                {
                    case ("input"):
                        message = new InputMessage(msg);
                        break;
                    default:
                        message = new StatusMessage(msg);
                        break;
                }
                if(OnNewMessage!=null)
                OnNewMessage(message);
            }
        }
    }
}


