/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
namespace ExperienceManager
{
    public abstract class Processor
    {
        ProcessCore core;
        
        public Processor(ProcessCore core)
        {
            this.core = core;
            core.OnNewMessage += Process;
        }

        protected virtual void Completed()
        {
            core.OnNewMessage -= Process;
        }

        protected virtual void Failed()
        {
            core.OnNewMessage -= Process;
        }

        public void Interrupt()
        {
            Failed();
        }

        protected abstract void Process(Message message);
    }
}


