/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System.Collections.Generic;
using System.Linq;

namespace Library
{
    public abstract class Action
    {
        public string name { get; set; }
        public IEnumerable<Argument> args { get; set; }

        public Action()
        {

        }

        public Action(string name,IEnumerable<Argument> args)
        {
            this.name = name;
            this.args = args.Select(z => new Argument(z));
        }

        public Action(string name,IEnumerable<Type> args)
        {
            this.name = name;
            this.args = args.Select(z => new Argument(z));
        }

        public override bool Equals(object obj)
        {
            if (obj.ToString().Equals("{DisconnectedItem}"))
                return false;
            return name.Equals(((Action)obj).name);
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}


