/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;

namespace Library
{
    public class Argument
    {
        Guid id;

        public Type type { get;private set; }
        public string title { get; set; }

        public Argument(Type type, string title = "")
        {
            this.type = type;
            this.title = title;
            id = Guid.NewGuid();
        }

        public Argument(Argument arg) : this(arg.type,arg.title) { }

        public bool Matches(Argument arg)
        {
            return arg.type.Matches(type);
        }

        public override bool Equals(object obj)
        {
            if (obj is Argument)
            {
                return id == (obj as Argument).id;
            }
            else
                return base.Equals(obj);
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

    }
}


