/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
namespace Library
{
    public class BoundArgument
    {
        public object binding { get; private set; }

        public bool bound
        {
            get
            {
                return (binding is int ? (int)binding >= 0 : (binding is string ? binding != null : false));
            }
        }

        public Argument argument { get; private set; }

        public BoundArgument(Argument argument)
        {
            this.argument = argument;
            binding = -1;
        }

        public BoundArgument(BoundArgument bound_argument)
        {
            this.argument = new Argument(bound_argument.argument);
            binding = -1;
        }

        public void Binding(int binding = -1)
        {
            this.binding = binding;
        }

        public void Binding(string binding = "")
        {
            this.binding = binding;
        }
    }
}


