/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System.Collections.Generic;
using System.Linq;

namespace Library
{
    public class Sequence<T>
    {
        public T header { get; private set; }

        public Sequence(T header)
        {
            this.header = header;
            this.steps = new List<UAction>();
        }

        public List<UAction> steps { get; set; }

        public Sequence()
        {
            this.steps = new List<UAction>();
        }

        public void Add(UAction uaction)
        {
            steps.Add(uaction);
        }

        public void Remove(UAction uaction)
        {
            steps.Remove(uaction);
        }

        public UAction this[int index]
        {
            get { return index==-1?null:steps[index]; }
        }

        public UAction this[UAction uaction]
        {
            get { return steps.FirstOrDefault(z => z.Equals(uaction)); }
        }

        public bool bound
        {
            get
            {
                return steps.Any(z => !z.bound);
            }
        }
    }
}


