/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Library
{
    public class TypeCollection
    {
        List<Type> types;

        public Type this[int index]
        {
            get { return types[index]; }
        }

        public Type this[string name]
        {
            get {
                return types.FirstOrDefault(z => z.name.ToLower().Equals(name.ToLower())) ??
                  throw new System.Exception("'" + name + "' type does not exist in the domain file"); }
        }

        public TypeCollection()
        {
            types = new List<Type>();
        }

        public Type Get(string name)
        {
            return types.FirstOrDefault(z => z.name.Equals(name));
        }

        public bool Add(string name)
        {
            if (types.Any(z => z.name.Equals(name)))
                return false;
            types.Add(new Type(name));
            return true;
        }
    }
}


