/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System.Collections.Generic;
using System.Linq;

namespace Library
{
    public class UAction
    {
        public bool primary { get; set; }

        public MicroAction action { get; private set; }
        public List<BoundArgument> boundArguments { get; private set; }

        public UAction(MicroAction action)
        {
            this.action = new MicroAction(action.name, action.args);
            this.boundArguments = this.action.args.Select(z => new BoundArgument(z)).ToList();
        }
        
        public bool bound
        {
            get { return boundArguments.All(z => z.bound); }
        }

        public BoundArgument this[int index]
        {
            get
            {
                return index==-1?null:boundArguments[index];
            }
        }
    }
}


