/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using Library;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Library
{
    public class UnityActionTranslator : Translator
    {
        public UnityActionTranslator(string path) : base(path)
        {
        }

        protected override IEnumerable<Action> Actions()
        {
            if (!Directory.Exists(path))
                yield break;
            foreach (var file in Directory.GetFiles(path))
            {
                if (!file.Contains("meta"))
                {
                    yield return new MicroAction(file.Substring(file.LastIndexOf('\\') + 1,
                        file.LastIndexOf('.') - 1 - file.LastIndexOf('\\')),
                    File.ReadAllLines(file).Where(z => z.Contains("<type>")).
                        Select(z => new Argument(collection[z.Substring(
                            z.IndexOf('>') + 1, z.LastIndexOf('<') - z.IndexOf('>') - 1)] )).ToList());
                }
            }
        }
    }
}


