/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    internal class ActionGetter : IGetter
    {
        string value;
        public ActionGetter(string value, List<Argument> args)
        {
            int temp = 0;
            string format = string.Format("{0}(", value);
            foreach (var arg in args)
            {
                format += int.TryParse(arg.ToString(), out temp) ? "{" + arg.ToString() + "}" : arg.ToString();
                format += ", ";
            }
            if (format.Contains(','))
                format = format.Substring(0, format.Length - 2);
            format += ")";
            this.value = format;
        }

        public List<string> Get(List<string> list, Database database=null)
        {
            return list==null?new List<string>():new List<string>() { string.Format(value, list.ToArray()) };
        }
    }
}


