/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    public static class Extensions
    {
        public static IEnumerable<string> Foreach(this List<Item> list, Func<string ,string> function)
        {
            foreach (var item in list)
            {
                yield return function(item["name"]);
            }
        }

        public static string GetString(this string value)
        {
            if (!Database.strings.ContainsKey(value))
                Database.strings.Add(value, value);
            return Database.strings[value];
        }
    }
}


