/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Medium
{
    internal class Fields:Dictionary<string,string>
    {
        string path = @"fields.txt";
        public Fields()
        {
            if (File.Exists(path))
            {
                foreach (var item in File.ReadAllLines(path))
                {
                    var values = item.Split('=');
                    Add(values[0], values[1]);
                }
            }
        }

        internal string Get(string type, params string[] args)
        {
            string key = string.Format("{0}(",type);
            for (int i = 0; i < args.Length; i++)
            {
                key += args[i];
                if (i < args.Length - 1)
                    key += ", ";
            }
            key += ")";
            return this[key];
        }
    }
}


