/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    internal class Fluents:Dictionary<string, string>, ValueSet
    {
        public new string this[string key]
        {
            get
            {
                if (!ContainsKey(key.ToLower()))
                    return null;
                return base[key.ToLower()];
            }
            set
            {
                base[key.ToLower()] = value;
            }
        }

        public bool IsTrue(string name)
        {
            var name_lower = name.ToLower();
            if (ContainsKey(name_lower))
                return this[name_lower].Equals(bool.TrueString);
            return false;
        }

        public bool IsFalse(string name)
        {
            var name_lower = name.ToLower();
            if (ContainsKey(name_lower))
                return this[name_lower].Equals(bool.FalseString);
            Add(name_lower, bool.FalseString);
            return true;
        }

        public void SetFalse(string name)
        {
            var name_lower = name.ToLower();
            if (!ContainsKey(name_lower))
                Add(name_lower, bool.FalseString);
            else
                this[name_lower] = bool.FalseString;
        }

        public void SetTrue(string name)
        {
            var name_lower = name.ToLower();
            if (!ContainsKey(name_lower))
                Add(name_lower, bool.TrueString);
            else
                this[name_lower] = bool.TrueString;
        }

        internal void Set(string key, string value)
        {
            var key_lower = key.ToLower();
            if (!ContainsKey(key_lower))
                Add(key_lower, value);
            else
                this[key_lower] = value;
        }
    }
}


