/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    public class Icons:Dictionary<string, List<string>>,ValueSet
    {
        public string Enable(string name, string action,string icon="",string description="",bool defaultIcon=true)
        {
            if (ContainsKey(name))
            {
                if (!this[name].Contains(action))
                    this[name].Add(action);
            }
            else
                this.Add(name, new List<string>() { action });
            return string.Format("EnableIcon({0}, {1}, {2}, '{3}', {4})", action,icon, name, description,defaultIcon.ToString());
        }

        internal List<string> DisableAll(string name)
        {
            if (ContainsKey(name))
            {
                var list = this[name].Select(z=>string.Format("DisableIcon({0}, {1})", z, name)).ToList();
                this[name].Clear();
                return list;
            }
            return new List<string>();
        }

        internal string DisableAll(string name, string icon)
        {
            if (ContainsKey(name))
            {
                this[name].Remove(icon);
                return string.Format("DisableIcon({1}, {0})", name, icon);
            }
            return null;
        }
    }
}


