/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    public class Item:Dictionary<string, Func<string>>
    {
        public Item(string name)
        {
            Add("name", name);
        }

        public new string this[string name]
        {
            get
            {
                return ContainsKey(name) ? base[name]() : null;
            }
        }

        public Item Add(string name, string value)
        {
            base.Add(name, ()=> { return value; });
            return this;
        }

        public new Item Add(string name, Func<string> function)
        {
            base.Add(name, function);
            return this;
        }
    }
}


