/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;

namespace Medium
{
    public class Strings:Dictionary<string, string>
    {
        const string delimiter = "@";
        string path = @"\strings.txt";
        public Strings()
        {
            var local = new FileInfo(new Uri(Assembly.GetEntryAssembly().GetName().CodeBase).AbsolutePath).Directory.FullName.Replace("%20", " ");
            path = local + path;
            if (!File.Exists(path))
                File.Create(path).Close();
            foreach (var line in File.ReadAllLines(path))
            {
                var values = line.Split('@');
                if(values.Length>1&&!this.ContainsKey(values[0]))
                base.Add(values[0],values[1]);
            }
        }
        
        public new void Add(string key, string value)
        {
            base.Add(key, value);
            File.AppendAllLines(path, new List<string>() { string.Format("{0}@{1}", key, value) });
        }
    }
}


