/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Medium
{
    public class Task
    {
        IGetter getter;

        public bool dontwait { get; set; }

        internal Task(string value,List<Argument> args)
        {
            getter = new ActionGetter(value, args);
        }
        
        internal Task(System.Action<List<string>, Database> todo, List<Argument> indices)
        {
            getter = new Getter<Action<List<string>,Database>>(todo, indices);
        }

        internal Task(Func<List<string>,Database, List<string>> function, List<Argument> indices)
        {
            getter = new Getter<Func<List<string>,Database, List<string>>>(function, indices);
        }

        internal Task(Func<List<string>,Database, string> function, List<Argument> indices)
        {
            getter = new Getter<Func<List<string>, Database, string>>(function, indices);
        }

        internal List<string> Do(List<string> list,Database database)
        {
            return getter.Get(list,database);
        }

    }
}


