/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace PlotGraph
{
    internal class ActionNameMapper: List<string>
    {
        internal ActionNameMapper(string path)
        {
            if (!File.Exists(path))
                throw new Exception("The file does not exist");

            foreach (var line in File.ReadAllLines(path))
            {
                this.Add(line);
            }
        }

        internal new string this[int key]
        {
            get
            {
                if (key>=this.Count)
                    throw new Exception("There is no action in the map for the specified key");
                return base[key];
            }
        }
    }
}


