/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlotGraph
{
    public class HugeList<T>
    {
        List<List<T>> list;
        public HugeList()
        {
            list = new List<List<T>>();
            list.Add(new List<T>());
        }
        public void Add(T num)
        {
            try
            {
                list.Last().Add(num);
            }
            catch(OutOfMemoryException)
            {
                list.Add(new List<T>());
                list.Last().Add(num);
            }
        }
        public T this[long index]
        {
            get
            {
                int current = 0;
                long temp = index;
                while (temp>list[current].Count)
                {
                    current++;
                    temp -= list[current].Count;
                }
                return list[current][(int)temp];
            }
        }

        internal string[] ToStringArray()
        {
            var strings = new List<string>();
            for (int i = 0; i < list.Count; i++)
            {
                strings.AddRange(list[i].Select(z => z.ToString()));
            }
            return strings.ToArray();
        }
    }
}


