/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlotGraph
{
    public static class JSONExtention
    {
        public static IEnumerable<T> Select<T, X>(this SimpleJSON.JSONNode array, Func<X, T> func) where X : SimpleJSON.JSONObject
        {
            foreach (X item in array.AsArray)
            {
                yield return func(item);
            }
        }

        public static IEnumerable<T> Select<T>(this SimpleJSON.JSONNode array, Func<SimpleJSON.JSONObject, T> func)
        {
            foreach (SimpleJSON.JSONNode item in array.AsArray)
            {
                yield return func(item.AsObject);
            }
        }

        public static IEnumerable<string> AsEnumerable(this SimpleJSON.JSONArray array)
        {
            foreach (SimpleJSON.JSONNode item in array)
            {
                yield return item.Value;
            }
        }

    }
}


