/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;

namespace PlotGraph
{
    public class Logger
    {
        const string folder = "Experience Manager Logs";
        string path;
        static string plotpath;
        string Path(params string[] strings)
        {
            string output = "";
            for (int i = 0; i < strings.Length; i++)
            {
                output += "{" + i + "}/";
            }
            var result= string.Format(output, strings);
            return result.Substring(0,result.Length - 1);
        }

        public Logger(string path, string id)
        {
            var folderPath = Path(folder, id);
            if (!Directory.Exists(folderPath))
                Directory.CreateDirectory(folderPath);
            path = Path(folderPath, path);
            var filename = path;
            if(path.IndexOf('.')>0)
             filename = path.Substring(0, path.LastIndexOf('.'));
            path = FilePath(filename);
            plotpath = FilePath(filename + "-plot");
            for (int i = 1; File.Exists(FilePath(filename, i - 1)); i++)
            {
                path = FilePath(filename, i);
                plotpath = FilePath(filename + "-plot", i);
            }
            File.Create(path).Close();
            File.Create(plotpath).Close();
            this.path = path;
        }

        public static void WritePlot(string msg)
        {
            File.AppendAllLines(plotpath, new List<string>() { msg });
        }

        private string FilePath(string filename, int extension = 0)
        {
            return string.Format("{0}{1}.txt", filename, extension.ToString());
        }

        public void Add(string text)
        {
            File.AppendAllLines(path, new List<string>() { text });
        }

        public void Add(List<string> text)
        {
            File.AppendAllLines(path, text);
        }

        public void Write(string text)
        {
            File.WriteAllLines(path, new List<string>() { text });
        }
    }
}


