/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Threading;
using System.Collections.Generic;
using System.Linq;
namespace ConsoleExperienceManager{
class Pair<T1, T2> {
public T1 First { get; private set; }
public T2 Second { get; private set; }
internal Pair(T1 first, T2 second) {
First = first;
Second = second; }
public override bool Equals(object obj){
var item = obj as Pair<T1, T2>;
if (item == null){ return false; }
return (this.First.Equals(item.First) && this.Second.Equals(item.Second)); }
public override int GetHashCode() { return this.GetHashCode(); }
}
static class Pair {
public static Pair<T1, T2> New<T1, T2>(T1 first, T2 second) {
var tuple = new Pair<T1, T2>(first, second);
return tuple; }}
class BuiltInCommunication : Communication{
private static List<Pair<string, string[]>> varList = new List<Pair<string, string[]>>();
private static Thread thread;
public BuiltInCommunication(string arg) : this(){}
public BuiltInCommunication() : base(null){
thread = new Thread(NotMain);
thread.Start(); }
private static bool checkVar(string key, int index, string value){
foreach (Pair<string, string[]> var in varList){
if (var.First.Equals(key) && var.Second[index].Equals(value)) return true; }
return false; }
private static void removeVar(string key, string[] values){
bool listsEqual;
for (int i = 0; i < varList.Count; i++){
if (varList[i].First.Equals(key)){
listsEqual = true;
for (int j = 0; j < values.Length; j++){
if (values[j] != varList[i].Second[j]) listsEqual = false;}
if (listsEqual) varList.RemoveAt(i); }}}
private static void groundActionWithVariable(Pair<string, string[]> var, string action, string line){ 
int varIndex; string groundedAction = action;
foreach (string t in action.Split(new char[]{' ', '(', ')', ',' })) {
if (t.Contains("[") && t.Substring(0, t.IndexOf('[')).Replace("$", "").Equals(var.First)){
varIndex = Convert.ToInt32(t.Substring(t.IndexOf('[') + 1, t.IndexOf(']') - t.IndexOf('[') - 1));
groundedAction = groundedAction.Replace(t, var.Second[varIndex]);}}
if (groundedAction.Contains("; wait")){
Console.WriteLine("start " + groundedAction.Substring(0, action.IndexOf(';')));
string arg = action.Split(' ').Last<string>();
if (arg.Equals("started")) while ((line = Console.ReadLine()) != "started " + groundedAction.Substring(0, action.IndexOf(';')).Replace("'", "").Replace(";", "")) { }
else if (arg.Equals("succeeded")) while ((line = Console.ReadLine()) != "succeeded " + action.Substring(0, action.IndexOf(';')).Replace("'", "").Replace(";", "")) { }
else Thread.Sleep(Int32.Parse(arg) * 1000); }
else Console.WriteLine("start " + groundedAction.Replace("; ", "")); }
private static void NotMain(){
Main(null); }
static void Main(string[] args){
bool gameOver = false;
string line;
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Coin"}));
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Gem"}));
varList.Add(new Pair<string, string[]>("inventoryShown", new string[]{"false"}));
varList.Add(new Pair<string, string[]>("merchantWares", new string[]{"Sword"}));
varList.Add(new Pair<string, string[]>("merchantWares", new string[]{"Potion"}));
varList.Add(new Pair<string, string[]>("chestContents", new string[]{"Gem"}));
Console.WriteLine("Camelot v0.1");
Console.WriteLine("start CreatePlace(OneRoomHouse, OneRoomHouse); wait succeeded");
Console.WriteLine("start CreatePlace(CastleFront, CastleFront); wait succeeded");
Console.WriteLine("start CreatePlace(Camp, Camp); wait succeeded");
Console.WriteLine("start CreatePlace(Market, Market); wait succeeded");
Console.WriteLine("start CreatePlace(Cottage, Cottage); wait succeeded");
Console.WriteLine("start CreateCharacter(Player, M); wait succeeded");
Console.WriteLine("start SetEyeColor(Player, Green);");
Console.WriteLine("start SetHairStyle(Player, Short);");
Console.WriteLine("start SetSkinColor(Player, 8);");
Console.WriteLine("start SetAge(Player, 30);");
Console.WriteLine("start SetWeight(Player, 150);");
Console.WriteLine("start SetClothing(Player, PeasantMale);");
Console.WriteLine("start SetPosition(Player, CastleFront);");
Console.WriteLine("start CreateCharacter(Merchant, F); wait succeeded");
Console.WriteLine("start SetHairStyle(Merchant, Shoulder);");
Console.WriteLine("start SetSkinColor(Merchant, 3);");
Console.WriteLine("start SetAge(Merchant, 50);");
Console.WriteLine("start SetWeight(Merchant, 150);");
Console.WriteLine("start SetClothing(Merchant, Servant);");
Console.WriteLine("start SetPosition(Merchant, Market.Merchant);");
Console.WriteLine("start CreateCharacter(Bandit, M); wait succeeded");
Console.WriteLine("start SetClothing(Bandit, Thief);");
Console.WriteLine("start SetWeight(Bandit, 200);");
Console.WriteLine("start SetAge(Bandit, 40);");
Console.WriteLine("start SetPosition(Bandit, Camp);");
Console.WriteLine("start CreateCharacter(Guard, M); wait succeeded");
Console.WriteLine("start SetClothing(Guard, Scale);");
Console.WriteLine("start SetWeight(Guard, 250);");
Console.WriteLine("start SetAge(Guard, 35);");
Console.WriteLine("start SetPosition(Guard, Market);");
Console.WriteLine("start CreateItem(Coin, Coin); wait succeeded");
Console.WriteLine("start CreateItem(Sword, Sword); wait succeeded");
Console.WriteLine("start CreateItem(Potion, Potion); wait succeeded");
Console.WriteLine("start CreateItem(Gem, Gem); wait succeeded");
Console.WriteLine("start SetCameraMode(object);");
Console.WriteLine("start SetCameraFocus(Player);");
Console.WriteLine("start EnableInput();");
while (!(line = Console.ReadLine()).StartsWith("error") && !gameOver){
if(line==""){}
else if (line == "input arrived Player position CastleFront.WestSign"){
Console.WriteLine("start EnableIcon(Open, CastleFront.WestSign, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, CastleFront.WestSign, Go, true)"){}
}
else if (line == "input arrived Player position Camp.ExitSign"){
Console.WriteLine("start EnableIcon(Open, Camp.ExitSign, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, Camp.ExitSign, Go, true)"){}
}
else if (line == "input arrived Player position CastleFront.EastSign"){
Console.WriteLine("start EnableIcon(Open, CastleFront.EastSign, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, CastleFront.EastSign, Go, true)"){}
}
else if (line == "input arrived Player position Cottage.Door"){
Console.WriteLine("start EnableIcon(Open, Cottage.Door, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, Cottage.Door, Go, true)"){}
}
else if (line == "input arrived Player position OneRoomHouse.Door"){
Console.WriteLine("start EnableIcon(Open, OneRoomHouse.Door, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, OneRoomHouse.Door, Go, true)"){}
}
else if (line == "input arrived Player position CastleFront.Gate"){
Console.WriteLine("start EnableIcon(Open, CastleFront.Gate, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, CastleFront.Gate, Go, true)"){}
}
else if (line == "input arrived Player position Market.Gate"){
Console.WriteLine("start EnableIcon(Open, Market.Gate, 'Go', true)");
while ((line = Console.ReadLine()) != "succeeded EnableIcon(Open, Market.Gate, Go, true)"){}
}
else if (line == "input exited Player position CastleFront.WestSign"){
Console.WriteLine("start DisableIcon(Open, CastleFront.WestSign)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, CastleFront.WestSign)"){}
}
else if (line == "input exited Player position Camp.ExitSign"){
Console.WriteLine("start DisableIcon(Open, Camp.ExitSign)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, Camp.ExitSign)"){}
}
else if (line == "input exited Player position CastleFront.EastSign"){
Console.WriteLine("start DisableIcon(Open, CastleFront.EastSign)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, CastleFront.EastSign)"){}
}
else if (line == "input exited Player position Cottage.Door"){
Console.WriteLine("start DisableIcon(Open, Cottage.Door)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, Cottage.Door)"){}
}
else if (line == "input exited Player position OneRoomHouse.Door"){
Console.WriteLine("start DisableIcon(Open, OneRoomHouse.Door)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, OneRoomHouse.Door)"){}
}
else if (line == "input exited Player position CastleFront.Gate"){
Console.WriteLine("start DisableIcon(Open, CastleFront.Gate)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, CastleFront.Gate)"){}
}
else if (line == "input exited Player position Market.Gate"){
Console.WriteLine("start DisableIcon(Open, Market.Gate)");
while ((line = Console.ReadLine()) != "succeeded DisableIcon(Open, Market.Gate)"){}
}
else if (line == "input arrived Player position CastleFront.WestEnd"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Camp.Exit)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Camp.Exit)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Camp.ExitSign, 'Go', true)");
}
else if (line == "input arrived Player position CastleFront.EastEnd"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Cottage)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Cottage)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Cottage.Door, 'Go', true)");
}
else if (line == "input arrived Player position Camp.End"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, CastleFront.West)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, CastleFront.West)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, CastleFront.WestSign, 'Go', true)");
}
else if (line == "input arrived Player position Cottage.End"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, CastleFront.East)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, CastleFront.East)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, CastleFront.EastSign, 'Go', true)");
}
else if (line == "input Open CastleFront.WestSign"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,CastleFront.WestSign)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Camp.Exit)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Camp.Exit)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Camp.ExitSign, 'Go', true)");
}
else if (line == "input Open Camp.ExitSign"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,Camp.ExitSign)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, CastleFront.West)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, CastleFront.West)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, CastleFront.WestSign, 'Go', true)");
}
else if (line == "input Open CastleFront.EastSign"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,CastleFront.EastSign)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Cottage)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Cottage)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Cottage.Door, 'Go', true)");
}
else if (line == "input Open Cottage.Door"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,Cottage.Door)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, OneRoomHouse.Door)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, OneRoomHouse.Door)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, OneRoomHouse.Door, 'Go', true)");
}
else if (line == "input Open OneRoomHouse.Door"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,OneRoomHouse.Door)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Cottage.Door)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Cottage.Door)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Cottage.Door, 'Go', true)");
}
else if (line == "input Open CastleFront.Gate"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,CastleFront.Gate)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, Market.Gate)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, Market.Gate)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, Market.Gate, 'Go', true)");
}
else if (line == "input Open Market.Gate"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Open(Player,Market.Gate)");
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Player, CastleFront.North)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Player, CastleFront.North)"){}
Console.WriteLine("start SetCameraMode(object)");
while ((line = Console.ReadLine()) != "succeeded SetCameraMode(object)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "started FadeIn()"){}
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Open, CastleFront.Gate, 'Go', true)");
}
else if (line == "input Key Inventory" && checkVar("inventoryShown",0, "false")){
Console.WriteLine("start ClearList()");
while ((line = Console.ReadLine()) != "succeeded ClearList()"){}
if(checkVar("inventory", 0, "Coin")){
Console.WriteLine("start AddToList(Coin, Coin, 'one stinkin coin')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Coin, Coin, one stinkin coin)"){}
}
if(checkVar("inventory", 0, "Sword")){
Console.WriteLine("start AddToList(Sword, Sword, 'a steel sword')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Sword, Sword, a steel sword)"){}
}
if(checkVar("inventory", 0, "Potion")){
Console.WriteLine("start AddToList(Potion, Potion, 'a very important potion')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Potion, Potion, a very important potion)"){}
}
if(checkVar("inventory", 0, "Gem")){
Console.WriteLine("start AddToList(Gem, Gem, 'an intriguing gem')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Gem, Gem, an intriguing gem)"){}
}
Console.WriteLine("start ShowList(Player, 'Inventory')");
while ((line = Console.ReadLine()) != "succeeded ShowList(Player, Inventory)"){}
foreach (Pair<string, string[]> var in varList){ if(var.First.Equals("inventoryShown")){ var.Second[0] = "true";}}
}
else if (line == "input Key Inventory" && checkVar("inventoryShown",0, "true")){
Console.WriteLine("start HideList()");
foreach (Pair<string, string[]> var in varList){ if(var.First.Equals("inventoryShown")){ var.Second[0] = "false";}}
}
else if (line == "input Cancel"){
foreach (Pair<string, string[]> var in varList){ if(var.First.Equals("inventoryShown")){ var.Second[0] = "false";}}
Console.WriteLine("start HideList()");
while ((line = Console.ReadLine()) != "succeeded HideList()"){}
}
else if (line == "input arrived Player position Camp.Chest"){
Console.WriteLine("start EnableIcon(Open, Camp.Chest, 'Open', true)");
}
else if (line == "input Open Camp.Chest"){
Console.WriteLine("start ClearList()");
if(checkVar("chestContents", 0, "Coin")){
Console.WriteLine("start AddToList(Coin, Coin, 'one stinkin coin')");
}
if(checkVar("chestContents", 0, "Sword")){
Console.WriteLine("start AddToList(Sword, Sword, 'a steel sword')");
}
if(checkVar("chestContents", 0, "Potion")){
Console.WriteLine("start AddToList(Potion, Potion, 'a very important potion')");
}
if(checkVar("chestContents", 0, "Gem")){
Console.WriteLine("start AddToList(Gem, Gem, 'an intriguing gem')");
}
foreach (Pair<string, string[]> var in varList){
groundActionWithVariable(var, "EnableIcon(Take, $chestContents[0], 'Take', true);", line);
}
Console.WriteLine("start ShowList(Camp.Chest, 'Chest Contents')");
}
else if (line == "input Take Coin" && checkVar("chestContents",0, "Coin")){
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Coin"}));
removeVar("chestContents", new string[]{"Coin"});
}
else if (line == "input Take Sword" && checkVar("chestContents",0, "Sword")){
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Sword"}));
removeVar("chestContents", new string[]{"Sword"});
}
else if (line == "input Take Potion" && checkVar("chestContents",0, "Potion")){
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Potion"}));
removeVar("chestContents", new string[]{"Potion"});
}
else if (line == "input Take Gem" && checkVar("chestContents",0, "Gem")){
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Gem"}));
removeVar("chestContents", new string[]{"Gem"});
}
else if (line == "input exited Player position Camp.Chest"){
Console.WriteLine("start DisableIcon(Open, Camp.Chest)");
}
else if (line == "input arrived Player position Merchant"){
Console.WriteLine("start EnableIcon(TalkTo, Merchant, 'Talk to Merchant', true)");
}
else if (line == "input exited Player position Merchant"){
Console.WriteLine("start DisableIcon(TalkTo, Merchant)");
}
else if (line == "input TalkTo Merchant"){
Console.WriteLine("start SetLeft(Player)");
Console.WriteLine("start SetRight(Merchant)");
Console.WriteLine("start SetDialog('Take a look at my fine wares! [ShowMerchandise|Ok] [Nevermind|Never mind]')");
Console.WriteLine("start ShowDialog()");
}
else if (line == "input Selected Nevermind"){
Console.WriteLine("start HideDialog()");
}
else if (line == "input Selected ShowMerchandise"){
Console.WriteLine("start HideDialog()");
Console.WriteLine("start ClearList()");
if(checkVar("merchantWares", 0, "Coin")){
Console.WriteLine("start AddToList(Coin, Coin, 'one stinkin coin')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Coin, Coin, one stinkin coin)"){}
}
if(checkVar("merchantWares", 0, "Sword")){
Console.WriteLine("start AddToList(Sword, Sword, 'a steel sword')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Sword, Sword, a steel sword)"){}
}
if(checkVar("merchantWares", 0, "Potion")){
Console.WriteLine("start AddToList(Potion, Potion, 'a very important potion')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Potion, Potion, a very important potion)"){}
}
if(checkVar("merchantWares", 0, "Gem")){
Console.WriteLine("start AddToList(Gem, Gem, 'an intriguing gem')");
while ((line = Console.ReadLine()) != "succeeded AddToList(Gem, Gem, an intriguing gem)"){}
}
foreach (Pair<string, string[]> var in varList){
groundActionWithVariable(var, "EnableIcon(Buy, $merchantWares[0], 'Buy for 1 coin', true);", line);
}
foreach (Pair<string, string[]> var in varList){
groundActionWithVariable(var, "EnableIcon(Steal, $merchantWares[0], 'Steal');", line);
}
Console.WriteLine("start ShowList(Merchant, 'Merchant Wares')");
while ((line = Console.ReadLine()) != "succeeded ShowList(Merchant, Merchant Wares)"){}
}
else if (line == "input Buy Potion" && checkVar("inventory",0, "Coin")){
Console.WriteLine("start HideList()");
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Potion"}));
removeVar("merchantWares", new string[]{"Potion"});
removeVar("inventory", new string[]{"Coin"});
}
else if (line == "input Buy Sword" && checkVar("inventory",0, "Coin")){
Console.WriteLine("start HideList()");
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Sword"}));
removeVar("merchantWares", new string[]{"Sword"});
removeVar("inventory", new string[]{"Coin"});
}
else if (line == "input Steal Potion"){
Console.WriteLine("start HideList()");
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Potion"}));
removeVar("merchantWares", new string[]{"Potion"});
Console.WriteLine("start WalkTo(Guard, Player)");
}
else if (line == "input Steal Sword"){
Console.WriteLine("start HideList()");
varList.Add(new Pair<string, string[]>("inventory", new string[]{"Sword"}));
removeVar("merchantWares", new string[]{"Sword"});
Console.WriteLine("start WalkTo(Guard, Player)");
}
else if (line == "input arrived Player position CastleFront.Gate" && checkVar("inventory",0, "Potion")){
Console.WriteLine("start SetPosition(Bandit, CastleFront)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Bandit, CastleFront)"){}
Console.WriteLine("start WalkTo(Bandit, Player)");
}
}}}}


