/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
using System;
using System.Threading;
using System.Collections.Generic;
namespace ConsoleExperienceManager{
class Program : Communication{
private static Thread thread;
public Program(string arg) : base(arg){
thread = new Thread(NotMain);
thread.Start(); }
private static void NotMain(){
Main(null); }
static void Main(string[] args){
HashSet<string> playerLocation = new HashSet<string>();
playerLocation.Add("Courtyard");
HashSet<string> swordPosition = new HashSet<string>();
swordPosition.Add("sheathed");
HashSet<string> tableContents = new HashSet<string>();
tableContents.Add("Cup1");
tableContents.Add("Cup2");
HashSet<string> inventory = new HashSet<string>();
inventory.Add("sword");
bool gameOver = false;
string line;
Console.WriteLine("Camelot v0.1");
Console.WriteLine("start SetPosition(Vizzini, Courtyard, null)");
Console.WriteLine("start SetPosition(Westley, DiningRoom, null)");
Console.WriteLine("start SetPosition(Cup1, DiningRoom, OnDiningRoomTable)");
Console.WriteLine("start SetPosition(Cup2, DiningRoom, OnDiningRoomTable)");
Console.WriteLine("start SetCameraMode(object)");
Console.WriteLine("start SetCameraFocus(Vizzini)");
Console.WriteLine("start EnableInput()");
Console.WriteLine("start EnableIcon(Draw, Sword, 'Draw sword')");
while (!(line = Console.ReadLine()).StartsWith("error") && !gameOver){
if(line==""){}
else if (line == "input arrived Vizzini position CourtyardDoor"){
Console.WriteLine("start EnableIcon(Open, CourtyardDoor, 'Open door')");
}
else if (line == "input arrived Vizzini position DiningRoomDoor"){
Console.WriteLine("start EnableIcon(Open, DiningRoomDoor, 'Open door')");
}
else if (line == "input exited Vizzini position CourtyardDoor"){
Console.WriteLine("start DisableIcon(Open, CourtyardDoor)");
}
else if (line == "input exited Vizzini position DiningRoomDoor"){
Console.WriteLine("start DisableIcon(Open, DiningRoomDoor)");
}
else if (line == "input arrived Vizzini position Westley" && swordPosition.SetEquals(new HashSet<string>(){"sheathed"})){
Console.WriteLine("start EnableIcon(TalkTo, Westley, 'Talk to Westley')");
}
else if (line == "input arrived Vizzini position Westley" && swordPosition.SetEquals(new HashSet<string>(){"drawn"})){
Console.WriteLine("start EnableIcon(Attack, Westley, 'Attack Westley!')");
}
else if (line == "input exited Vizzini position Westley"){
Console.WriteLine("start DisableIcon(TalkTo, Westley)");
Console.WriteLine("start DisableIcon(Attack, Westley)");
}
else if (line == "input arrived Vizzini position DiningRoomTable"){
Console.WriteLine("start EnableIcon(Take, Cup1, 'Take')");
Console.WriteLine("start EnableIcon(Take, Cup2, 'Take')");
}
else if (line == "input exited Vizzini position DiningRoomTable"){
Console.WriteLine("start DisableIcon(Take, Cup1)");
Console.WriteLine("start DisableIcon(Take, Cup2)");
}
else if (line == "input Take Cup1"){
inventory.Add("Cup1");
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Take(Vizzini, Cup1)");
while ((line = Console.ReadLine()) != "succeeded Take(Vizzini, Cup1)"){}
Console.WriteLine("start Take(Westley, Cup2)");
while ((line = Console.ReadLine()) != "succeeded Take(Westley, Cup2)"){}
Console.WriteLine("start Drink(Westley, Cup2)");
Console.WriteLine("start Drink(Vizzini, Cup1)");
while ((line = Console.ReadLine()) != "succeeded Drink(Vizzini, Cup1)"){}
Console.WriteLine("start Die(Vizzini)");
while ((line = Console.ReadLine()) != "succeeded Die(Vizzini)"){}
Console.WriteLine("start SetNarration('Pity... The glass you chose was poisoned. The battle of wits has ended, and you have lost!')");
while ((line = Console.ReadLine()) != "succeeded SetNarration(Pity... The glass you chose was poisoned. The battle of wits has ended, and you have lost!)"){}
Console.WriteLine("start ShowNarration()");
}
else if (line == "input Take Cup2"){
inventory.Add("Cup2");
Console.WriteLine("start DisableInput()");
Console.WriteLine("start Take(Vizzini, Cup2)");
while ((line = Console.ReadLine()) != "succeeded Take(Vizzini, Cup2)"){}
Console.WriteLine("start Take(Westley, Cup1)");
while ((line = Console.ReadLine()) != "succeeded Take(Westley, Cup1)"){}
Console.WriteLine("start Drink(Westley, Cup1)");
Console.WriteLine("start Drink(Vizzini, Cup2)");
while ((line = Console.ReadLine()) != "succeeded Drink(Vizzini, Cup2)"){}
Console.WriteLine("start Die(Vizzini)");
while ((line = Console.ReadLine()) != "succeeded Die(Vizzini)"){}
Console.WriteLine("start SetNarration('Pity... The glass you chose was poisoned. The battle of wits has ended, and you have lost!')");
while ((line = Console.ReadLine()) != "succeeded SetNarration(Pity... The glass you chose was poisoned. The battle of wits has ended, and you have lost!)"){}
Console.WriteLine("start ShowNarration()");
}
else if (line == "input TalkTo Westley"){
Console.WriteLine("start SetLeft(Vizzini)");
Console.WriteLine("start SetRight(Westley)");
Console.WriteLine("start SetDialog('I challenge you to a battle of wits! I have placed a deadly poison in one of the glasses---but which? Choose your glass and I will drink the other. The game ends when you decide, and one of us is dead. \n\n[Ok]')");
while ((line = Console.ReadLine()) != "succeeded SetDialog(I challenge you to a battle of wits! I have placed a deadly poison in one of the glasses---but which? Choose your glass and I will drink the other. The game ends when you decide, and one of us is dead. \n\n[Ok])"){}
Console.WriteLine("start ShowDialog()");
}
else if (line == "input Selected Ok"){
Console.WriteLine("start HideDialog()");
}
else if (line == "input Open CourtyardDoor"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start OpenDoor(Vizzini, CourtyardDoor)");
while ((line = Console.ReadLine()) != "succeeded OpenDoor(Vizzini, CourtyardDoor)"){}
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Vizzini, DiningRoom, DiningRoomDoor)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Vizzini, DiningRoom, DiningRoomDoor)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "succeeded FadeIn()"){}
Console.WriteLine("start EnableInput()");
}
else if (line == "input Open DiningRoomDoor"){
Console.WriteLine("start DisableInput()");
Console.WriteLine("start OpenDoor(Vizzini, DiningRoomDoor)");
while ((line = Console.ReadLine()) != "succeeded OpenDoor(Vizzini, DiningRoomDoor)"){}
Console.WriteLine("start FadeOut()");
while ((line = Console.ReadLine()) != "succeeded FadeOut()"){}
Console.WriteLine("start SetPosition(Vizzini, Courtyard, CourtyardDoor)");
while ((line = Console.ReadLine()) != "succeeded SetPosition(Vizzini, Courtyard, CourtyardDoor)"){}
Console.WriteLine("start FadeIn()");
while ((line = Console.ReadLine()) != "succeeded FadeIn()"){}
Console.WriteLine("start EnableInput()");
}
else if (line == "input Draw Sword"){
swordPosition = new HashSet<string>(){"drawn"};
Console.WriteLine("start DisableIcon(Draw, Sword)");
Console.WriteLine("start Draw(Sword, Vizzini)");
while ((line = Console.ReadLine()) != "succeeded Draw(Sword, Vizzini)"){}
Console.WriteLine("start EnableIcon(Sheathe, Sword, 'Sheathe sword')");
}
else if (line == "input Sheathe Sword"){
swordPosition = new HashSet<string>(){"sheathed"};
Console.WriteLine("start DisableIcon(Sheathe, Sword)");
Console.WriteLine("start Sheathe(Sword, Vizzini)");
while ((line = Console.ReadLine()) != "succeeded Sheathe(Sword, Vizzini)"){}
Console.WriteLine("start EnableIcon(Draw, Sword, 'Draw sword')");
}
else if (line == "input Attack Westley"){
Console.WriteLine("start Attack(Vizzini, Westley)");
}
}}}}


