/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
/ door[door-name, destination-position, door-to-enable, camera-mode]
door[CastleFront.WestSign, Camp.Exit, Camp.ExitSign, object]
door[Camp.ExitSign, CastleFront.West, CastleFront.WestSign, object]
door[CastleFront.EastSign, Cottage, Cottage.Door, object]
door[Cottage.Door, OneRoomHouse.Door, OneRoomHouse.Door, object]
door[OneRoomHouse.Door, Cottage.Door, Cottage.Door, object]
door[CastleFront.Gate, Market.Gate, Market.Gate, object]
door[Market.Gate, CastleFront.North, CastleFront.Gate, object]

// transition[position-name, destination-position, door-to-enable, camera-mode]
transition[CastleFront.WestEnd, Camp.Exit, Camp.ExitSign, object]
transition[CastleFront.EastEnd, Cottage, Cottage.Door, object]
transition[Camp.End, CastleFront.West, CastleFront.WestSign, object]
transition[Cottage.End, CastleFront.East, CastleFront.EastSign, object]

description[Coin, Coin, 'one stinkin coin']
description[Sword, Sword, 'a steel sword']
description[Potion, Potion, 'a very important potion']
description[Gem, Gem, 'an intriguing gem']

merchandise[Potion, Coin]
merchandise[Sword, Coin]

$inventory[Coin]
$inventory[Gem]
$inventoryShown[false]
$merchantWares[Sword]
$merchantWares[Potion]
$chestContents[Gem]

init {
	CreatePlace(OneRoomHouse, OneRoomHouse); wait succeeded
	CreatePlace(CastleFront, CastleFront); wait succeeded
	CreatePlace(Camp, Camp); wait succeeded
	CreatePlace(Market, Market); wait succeeded
	CreatePlace(Cottage, Cottage); wait succeeded
	CreateCharacter(Player, M); wait succeeded
	SetEyeColor(Player, Green);
	SetHairStyle(Player, Short);
	SetSkinColor(Player, 8);
	SetAge(Player, 30);
	SetWeight(Player, 150);
	SetClothing(Player, PeasantMale);
	SetPosition(Player, CastleFront);
	CreateCharacter(Merchant, F); wait succeeded	
	SetHairStyle(Merchant, Shoulder);
	SetSkinColor(Merchant, 3);
	SetAge(Merchant, 50);
	SetWeight(Merchant, 150);
	SetClothing(Merchant, Servant);
	SetPosition(Merchant, Market.Merchant);
	CreateCharacter(Bandit, M); wait succeeded
	SetClothing(Bandit, Thief);
	SetWeight(Bandit, 200);
	SetAge(Bandit, 40);
	SetPosition(Bandit, Camp);
	CreateCharacter(Guard, M); wait succeeded
	SetClothing(Guard, Scale);
	SetWeight(Guard, 250);
	SetAge(Guard, 35);
	SetPosition(Guard, Market);
	CreateItem(Coin, Coin); wait succeeded
	CreateItem(Sword, Sword); wait succeeded
	CreateItem(Potion, Potion); wait succeeded
	CreateItem(Gem, Gem); wait succeeded
	SetCameraMode(object);
	SetCameraFocus(Player);
	EnableInput();
}

when input arrived Player position CastleFront.Gate & $inventory[0] = Potion {
	SetPosition(Bandit, CastleFront); wait succeeded
	WalkTo(Bandit, Player);
}

when input arrived Player position door[0] {
	EnableIcon(Open, door[0], 'Go', true); wait succeeded
}

when input exited Player position door[0] {
	DisableIcon(Open, door[0]); wait succeeded
}

when input arrived Player position transition[0] {
	DisableInput()
	FadeOut(); wait succeeded
	SetPosition(Player, transition[1]); wait succeeded
	SetCameraMode(transition[3]); wait succeeded
	FadeIn(); wait started
	EnableInput()
	EnableIcon(Open, transition[2], 'Go', true)
}

when input Open door[0] {
	DisableInput()
	Open(Player,door[0])
	FadeOut(); wait succeeded
	SetPosition(Player, door[1]); wait succeeded
	SetCameraMode(door[3]); wait succeeded
	FadeIn(); wait started
	EnableInput()
	EnableIcon(Open, door[2], 'Go', true)
}

when input Key Inventory & $inventoryShown[0] = false {
	ClearList(); wait succeeded
	forall description[0] = $inventory[0]
		AddToList(description[0], description[1], description[2]); wait succeeded
	ShowList(Player, 'Inventory'); wait succeeded
	$inventoryShown[0] = true;
}

when input Key Inventory & $inventoryShown[0] = true {
	HideList();
	$inventoryShown[0] = false;
}

when input Cancel {
	$inventoryShown[0] = false;
	HideList(); wait succeeded
}

when input arrived Player position Camp.Chest {
	EnableIcon(Open, Camp.Chest, 'Open', true);
}

when input Open Camp.Chest {
	ClearList();
	forall description[0] = $chestContents[0]
		AddToList(description[0], description[1], description[2]);
	forall $chestContents[0]
		EnableIcon(Take, $chestContents[0], 'Take', true);
	ShowList(Camp.Chest, 'Chest Contents');	
}

when input Take description[0] & $chestContents[0] = description[0] {
	$inventory[description[0]];
	-$chestContents[description[0]];
}

when input exited Player position Camp.Chest{
	DisableIcon(Open, Camp.Chest);
}

when input arrived Player position Merchant{
	EnableIcon(TalkTo, Merchant, 'Talk to Merchant', true);	
}

when input exited Player position Merchant{
	DisableIcon(TalkTo, Merchant);	
}

when input TalkTo Merchant{
	SetLeft(Player);
	SetRight(Merchant);
	SetDialog('Take a look at my fine wares! [ShowMerchandise|Ok] [Nevermind|Never mind]');
	ShowDialog();
}

when input Selected Nevermind{
	HideDialog();
}

when input Selected ShowMerchandise {
	HideDialog();
	ClearList();
	forall description[0] = $merchantWares[0]
		AddToList(description[0], description[1], description[2]); wait succeeded
	forall $merchantWares[0]
		EnableIcon(Buy, $merchantWares[0], 'Buy for 1 coin', true);
	forall $merchantWares[0]
		EnableIcon(Steal, $merchantWares[0], 'Steal');
	ShowList(Merchant, 'Merchant Wares'); wait succeeded
}

when input Buy merchandise[0] & $inventory[0] = merchandise[1] {
	HideList();
	$inventory[merchandise[0]];
	-$merchantWares[merchandise[0];
	-$inventory[merchandise[1]];
}

when input Steal merchandise[0] {
	HideList();
	$inventory[merchandise[0]];
	-$merchantWares[merchandise[0];
	WalkTo(Guard, Player);
}

