/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
/ door[door-name, destination-position, door-to-enable, destination-place, go-to-message]
door[CastleFront.WestSign, Camp, Camp.ExitSign, Camp, 'Go to the camp']
door[Camp.ExitSign, CastleFront.WestSign, CastleFront.WestSign, CastleFront, 'Go to the crossroads']
door[CastleFront.EastSign, Cottage, null, Cottage, 'Go to the cottage']
door[Cottage.Door, OneRoomHouse.Door, OneRoomHouse.Door, OneRoomHouse, 'Enter the cottage']
door[OneRoomHouse.Door, Cottage.Door, Cottage.Door, Cottage, 'Leave the cottage']
door[CastleFront.Gate, Market.Gate, Market.Gate, Market, 'Enter the castle']
door[Market.Gate, CastleFront.Gate, CastleFront.Gate, CastleFront, 'Leave the castle']

// transition[position-name, destination-position, door-to-enable, destination-place]
transition[CastleFront.WestEnd, Camp, Camp.ExitSign, Camp]
transition[CastleFront.EastEnd, Cottage, null, Cottage]
transition[Camp.Exit, CastleFront.WestSign, CastleFront.WestSign, CastleFront]
transition[Cottage.Exit, CastleFront.EastSign, CastleFront.EastSign, CastleFront]

interactables[OneRoomHouse, OneRoomHouse.Door]
interactables[OneRoomHouse, OneRoomHouse.Bed]
interactables[CastleFront, CastleFront.EastSign]
interactables[CastleFront, CastleFront.WestSign]
interactables[CastleFront, CastleFront.Gate]
interactables[Camp, Camp.Chest]
interactables[Camp, Camp.ExitSign]
interactables[Market, Merchant]
interactables[Market, Market.Gate]
interactables[Cottage, Cottage.Door]

description[Coin, 'One measly coin']
description[Sword, 'A steel sword']
description[Potion, 'A very important potion']
description[Gem, 'An intriguing gem']
description[Dagger, 'An ornate dagger']

merchandise[Potion, Gem, 'Cost: a valuable gem']
merchandise[Sword, Coin, 'Cost: 1 coin']

swordIcon[false, Draw, 'Draw sword'];
swordIcon[true, Sheathe, 'Sheathe sword'];

$inventory[Coin]
$inventoryShown[false]
$merchantWares[Potion]
$merchantWares[Sword]
$chestContents[Gem]
$swordDrawn[false]
$time['Day']
$banditChasing[false]
$patrol[true]
$playerLocation[Cottage]

init {
	CreatePlace(OneRoomHouse, OneRoomHouse); wait succeeded
	CreatePlace(CastleFront, CastleFront); wait succeeded
	CreatePlace(Camp, Camp); wait succeeded
	CreatePlace(Market, Market); wait succeeded
	CreatePlace(Cottage, Cottage); wait succeeded
	CreateCharacter(Player, M); wait succeeded
	SetEyeColor(Player, Green);
	SetHairStyle(Player, Short);
	SetSkinColor(Player, 8);
	SetAge(Player, 30);
	SetWeight(Player, 150);
	SetClothing(Player, PeasantMale);
	SetPosition(Player, OneRoomHouse);
	CreateCharacter(Merchant, F); wait succeeded	
	SetHairStyle(Merchant, Shoulder);
	SetSkinColor(Merchant, 3);
	SetAge(Merchant, 50);
	SetWeight(Merchant, 150);
	SetClothing(Merchant, Servant);
	SetPosition(Merchant, Market.Merchant);
	CreateCharacter(Bandit, M); wait succeeded
	SetClothing(Bandit, Thief);
	SetWeight(Bandit, 200);
	SetAge(Bandit, 40);
	SetPosition(Bandit, Camp.Lurking);
	CreateCharacter(Guard, M); wait succeeded
	SetClothing(Guard, Scale);
	SetWeight(Guard, 250);
	SetAge(Guard, 35);
	CreateItem(Coin, Coin);
	CreateItem(Sword, Sword);
	CreateItem(Sword2, Sword);
	CreateItem(Dagger, Sword); 
	SetPosition(Dagger, Bandit);
	SetPosition(Sword2, Guard);
	CreateItem(Potion, Potion);
	CreateItem(Gem, Gem);
	SetCameraMode(object);
	SetCameraFocus(Player);
	EnableInput();
	SetPosition(Guard, Market.East);
	FadeIn();
}

when succeeded WalkTo(Guard, Market.West) & $patrol[0] = true {
	WalkTo(Guard, Market.East);
}

when succeeded WalkTo(Guard, Market.East) & $patrol[0] = true {
	WalkTo(Guard, Market.West);
}

when started EnableInput() & $playerLocation[0] = Market{
	WalkTo(Guard, Market.West);
}

when succeeded FadeIn() & $playerLocation[0] = OneRoomHouse {
	forall $inventory[0] = Potion
		SetNarration('You did it!');
	EnableIcon(WalkTo, WalkTo, OneRoomHouse.Door, 'Go', true);
	EnableIcon(WalkTo, WalkTo, OneRoomHouse.Bed, 'Go', true);
}

when succeeded SetNarration(You did it!){
	ShowNarration(); wait 3
	Quit();
}

when succeeded FadeIn() & $playerLocation[0] = Cottage {
	EnableIcon(WalkTo, WalkTo, Cottage.Door, 'Go', true);
}

when succeeded FadeIn() & $playerLocation[0] = CastleFront {
	EnableIcon(WalkTo, WalkTo, CastleFront.EastSign, 'Go', true);
	EnableIcon(WalkTo, WalkTo, CastleFront.WestSign, 'Go', true);
	EnableIcon(WalkTo, WalkTo, CastleFront.Gate, 'Go', true);
}

when succeeded FadeIn() & $playerLocation[0] = Camp {
	EnableIcon(WalkTo, WalkTo, Camp.ExitSign, 'Go', true);
	EnableIcon(WalkTo, WalkTo, Camp.Chest, 'Go', true);
}

when succeeded FadeIn() & $playerLocation[0] = Market {
	EnableIcon(WalkTo, WalkTo, Market.Gate, 'Go', true);
	EnableIcon(WalkTo, WalkTo, Merchant, 'Go', true);
	WalkTo(Guard, Market.West);
}

when input WalkTo interactables[1] {
	WalkTo(Player, interactables[1]);
}

when succeeded WalkTo(Player, door[0]) & $banditChasing[0] = true{
	DisableInput()
	Exit(Player, door[0]);
	FadeOut(); wait succeeded
	SetPosition(Player, door[1]); wait succeeded
	$playerLocation[0] = door[3];
	FadeIn(); wait started
	EnableInput();
	WalkTo(Bandit, door[0]);
}

when succeeded WalkTo(Player, door[0]){
	DisableInput()
	Exit(Player, door[0]); wait succeeded
	FadeOut(); wait succeeded
	SetPosition(Player, door[1]); wait succeeded
	$playerLocation[0] = door[3];
	FadeIn(); wait started
	EnableInput();
}

when succeeded WalkTo(Player, OneRoomHouse.Bed) & $time[0] = 'Day'{
	DisableInput();
	FadeOut(); wait succeeded
	SetNight(); 
	$time[0] = 'Night';
	FadeIn(); wait started
	EnableInput();	
}

when succeeded WalkTo(Player, OneRoomHouse.Bed) & $time[0] = 'Night'{
	DisableInput();
	FadeOut(); wait succeeded
	SetDay(); 
	$time[0] = 'Day';
	FadeIn(); wait started
	EnableInput();	
}

when started WalkTo(Bandit, Player){
	$banditChasing[0] = true;
}

when succeeded WalkTo(Bandit, Player) & $banditChasing[0] = true{
	DisableInput(); wait succeeded
	Attack(Bandit, Player);
}

when succeeded Attack(Player, Bandit){
	Die(Bandit); wait succeeded
	$banditChasing[0] = false;
	EnableInput();
}

when succeeded Attack(Bandit, Player){
	forall $swordDrawn[0] = false
		Die(Player);
	forall $swordDrawn[0] = true
		Attack(Player, Bandit);
}

when succeeded Die(Player){
	SetNarration('Game Over'); wait succeeded
	ShowNarration(); wait 3	
	Quit();	
}

when input arrived Player position door[0] {
	DisableIcon(WalkTo, door[0]);
	EnableIcon(Open, Open, door[0], door[4], true);
}

when input exited Player position door[0] {
	DisableIcon(Open, door[0]);
	EnableIcon(WalkTo, WalkTo, door[0], 'Go', true);
}

when input arrived Player position transition[0] & $banditChasing[0] = true {
	DisableInput()
	Exit(Player, transition[0]);
	FadeOut(); wait succeeded
	SetPosition(Player, transition[1]); wait succeeded
	$playerLocation[0] = transition[3];
	FadeIn(); wait started
	EnableInput()
	WalkTo(Bandit, transition[0]);
}

when input arrived Player position transition[0] {
	DisableInput()
	Exit(Player, transition[0]);
	FadeOut(); wait succeeded
	SetPosition(Player, transition[1]); wait succeeded
	$playerLocation[0] = transition[3];
	FadeIn(); wait started
	EnableInput();
}

when input Open door[0] & $banditChasing[0] = true {
	DisableInput()
	Exit(Player, door[0]);
	FadeOut(); wait succeeded
	SetPosition(Player, door[1]); wait succeeded
	$playerLocation[0] = door[3];
	FadeIn(); wait started
	EnableInput();
	WalkTo(Bandit, door[0]);
}

when input Open door[0] {
	DisableInput()
	Exit(Player, door[0]);
	FadeOut(); wait succeeded
	SetPosition(Player, door[1]); wait succeeded
	$playerLocation[0] = door[3];
	FadeIn(); wait started
	EnableInput();
}

when succeeded WalkTo(Bandit, door[0]){
	Exit(Bandit, door[0]);
}

when succeeded WalkTo(Bandit, transition[0]){
	Exit(Bandit, transition[0]);
}

when succeeded Exit(Bandit, door[0]){
	Enter(Bandit, door[1]);
}

when succeeded Exit(Bandit, transition[0]){
	Enter(Bandit, transition[1]);
}

when succeeded Enter(Bandit, Market.Gate){
	$patrol[0] = false;
	WalkTo(Guard, Bandit);
}

when succeeded Enter(Bandit, door[1]){
	WalkTo(Bandit, Player);
}

when succeeded Enter(Bandit, transition[1]){
	WalkTo(Bandit, Player);
}

when succeeded WalkTo(Guard, Bandit){
	$banditChasing[0] = false;
	Attack(Guard, Bandit);
}

when succeeded Attack(Guard, Bandit){
	Die(Bandit);
}

when input Key Inventory & $inventoryShown[0] = false{
	ClearList(); wait succeeded
	forall description[0] = $inventory[0]
		AddToList(description[0], description[1]); wait succeeded
	ShowList(Player, 'Inventory'); wait succeeded
	$inventoryShown[0] = true;
	forall swordIcon[0] = $swordDrawn[0]
		EnableIcon(swordIcon[1], swordIcon[1], Sword, swordIcon[2], true);
}

when input Key Inventory & $inventoryShown[0] = true {
	HideList();
	DisableIcon(Draw, Sword);
	DisableIcon(Sheathe, Sword);
	$inventoryShown[0] = false;
}

when input Cancel {
	HideList();
	DisableIcon(Draw, Sword);
	DisableIcon(Sheathe, Sword);
	$inventoryShown[0] = false;
}

when input Draw Sword {
	HideList();
	$inventoryShown[0] = false;
	Draw(Player, Sword);
	$swordDrawn[0] = true;
	DisableIcon(Draw, Sword);
	EnableIcon(Sheathe, Sheathe, Sword, 'Sheathe sword', true);
}

when input Sheathe Sword {
	HideList();
	$inventoryShown[0] = false;
	Sheathe(Player, Sword);
	$swordDrawn[0] = false;
	DisableIcon(Sheathe, Sword);
	EnableIcon(Draw, Draw, Sword, 'Draw sword', true);
}

when input arrived Player position OneRoomHouse.Bed {
	EnableIcon(Sleep, Sleep, OneRoomHouse.Bed, 'Sleep', true);
}

when input exited Player position OneRoomHouse.Bed {
	DisableIcon(Sleep, OneRoomHouse.Bed);
}

when input Sleep OneRoomHouse.Bed & $time[0] = 'Day' {
	DisableInput();
	FadeOut(); wait succeeded
	SetNight(); 
	$time[0] = 'Night';
	FadeIn(); wait started
	EnableInput();
}

when input Sleep OneRoomHouse.Bed & $time[0] = 'Night' {
	DisableInput();
	FadeOut(); wait succeeded
	SetDay();
	$time[0] = 'Day';
	FadeIn(); wait started
	EnableInput();
}

when input arrived Player position Camp.Chest {
	DisableIcon(WalkTo, Camp.Chest);
	EnableIcon(Open, Open, Camp.Chest, 'Open', true);
}

when input exited Player position Camp.Chest {
	DisableIcon(Open, Camp.Chest);
	EnableIcon(WalkTo, WalkTo, Camp.Chest, 'Go', true);
}

when input Open Camp.Chest {
	ClearList();
	forall description[0] = $chestContents[0]
		AddToList(description[0], description[1]);
	forall $chestContents[0]
		EnableIcon(Take, Take, $chestContents[0], 'Take', true);
	ShowList(Camp.Chest, 'Chest Contents');	
}

when input Take description[0] & $chestContents[0] = description[0] {
	HideList();
	$inventory[description[0]];
	-$chestContents[description[0]];
	WalkTo(Bandit, Player);
}

when input Take description[0] {
	$inventory[description[0]];
	Take(Player, description[0]);
}

when input arrived Player position Merchant{
	DisableIcon(WalkTo, Merchant);
	EnableIcon(TalkTo, TalkTo, Merchant, 'Talk to Merchant', true);	
}

when input exited Player position Merchant{
	DisableIcon(TalkTo, Merchant);
	EnableIcon(WalkTo, WalkTo, Merchant, 'Go', true);
}

when input TalkTo Merchant{
	SetLeft(Player);
	SetRight(Merchant);
	SetDialog('Take a look at my fine wares! [ShowMerchandise|Ok] [Nevermind|Never mind]');
	ShowDialog();
}

when input Selected Nevermind{
	HideDialog();
}

when input Selected ShowMerchandise {
	HideDialog();
	ClearList();
	forall merchandise[0] = $merchantWares[0]
		AddToList(merchandise[0], merchandise[2]); wait succeeded
	forall merchandise[0] = $merchantWares[0]
		EnableIcon(Buy, Buy, merchandise[0], merchandise[2], true);
	forall merchandise[0] = $merchantWares[0]
		EnableIcon(Steal, Steal, merchandise[0], 'Steal');
	ShowList(Merchant, 'Merchant Wares'); wait succeeded
}

when input Buy merchandise[0] & $inventory[0] = merchandise[1] {
	DisableIcon(Buy, merchandise[0]);
	DisableIcon(Steal, merchandise[0]);
	HideList();
	$inventory[merchandise[0]];
	-$merchantWares[merchandise[0]];
	-$inventory[merchandise[1]];
}

when input Buy merchandise[0] {
	SetNarration('You lack the required payment for this item.');
	ShowNarration(); wait 3
	HideNarration();
}

when input Steal merchandise[0] {
	DisableIcon(Steal, merchandise[0]);
	DisableIcon(Buy, merchandise[0]);
	HideList();
	SetExpression(Merchant, 'Scared')
	$inventory[merchandise[0]];
	-$merchantWares[merchandise[0];
	$patrol[0] = false;
	WalkTo(Guard, Player);
}

when succeeded WalkTo(Guard, Player){
	SetNarration('Thief! You are under arrest.')
	ShowNarration(); wait 3
	Quit();
}


