/*Copyright (c) Dr. Stephen Ware and the University of New Orleans. All rights reserved.
Contributors: Alireza Shirvani, Edward T. Garcia
Licensed under the Non-Profit Open Software License version 3.0. See LICENSE file in the project root for full license information.*/
/ Variables
door[Home.Door, Cottage.Door]
door[Crossroads.Gate, Market.Gate]
door[Market.Gate, Crossroads.Gate]

transition[Cottage.Exit, Crossroads.EastEnd]
transition[Crossroads.EastEnd, Cottage.Exit]
transition[Crossroads.WestEnd, Camp.Exit]
transition[Camp.Exit, Crossroads.WestEnd]

introduction[Grandma, 'I am your grandmother. Somewhere in this town there is a Guard... a Merchant... a Bandit... and a Chest. Can you find them all? [OkGrandma|Ok]']
introduction[Guard, 'I am the town guard. I want to catch criminals. [OkGuard|Ok]']
introduction[Merchant, 'I am a merchant. I want to sell my goods for gold. [OkMerchant|Ok]']
introduction[Bandit, 'I am a bandit. I want to have everything valuable! [OkBandit|Ok]']
introduction[Camp.Chest, 'Ooh look... a chest! [OkChest|Ok]']

$metGrandma[false]
$metGuard[false]
$metMerchant[false]
$metBandit[false]
$metChest[false]
$transitioning[false]

// Clothings to add:
//ChangeClothing(Player, PeasantMale);
//ChangeClothing(Merchant, Servant);
//ChangeClothing(Bandit, Thief);
//ChangeClothing(Guard, Scale);

// Setup
init {
	CreatePlace(Home, OneRoomHouse); wait succeeded
	CreatePlace(Crossroads, CastleFront); wait succeeded
	CreatePlace(Market, Market); wait succeeded
	CreatePlace(Camp, Camp); wait succeeded
	CreatePlace(Cottage, Cottage); wait succeeded

	CreateCharacter(Player, F); wait succeeded
	SetPosition(Player, Market.Gate);
	
	CreateCharacter(A, M); wait succeeded
	SetPosition(A, Market); wait succeeded
	SetCameraMode(follow);
	SetCameraFocus(Player); wait succeeded
	FadeIn(); wait succeeded
	
}

when succeeded FadeIn(){
	CreateItem(Bag_Coin, Bag_Coin); wait succeeded
	Give(Player, Bag_Coin, A)
}

// Dialog Interactions
when input WalkTo introduction[0] {
	WalkTo(Player, introduction[0]);
}

when succeeded WalkTo(Player, introduction[0]){
	SetRight(Player);
	SetLeft(introduction[0]);
	SetDialog(introduction[1]);
	ShowDialog();	
}


when input WalkTo Cottage.Door & $metGrandma[0] = true {
	WalkTo(Player, Cottage.Door);
}

// Win condition
when succeeded WalkTo(Player, Cottage.Door) & $metGuard[0] = true & $metMerchant[0] = true & $metBandit[0] = true & $metChest[0] = true {
	SetNarration('You did it!');
	ShowNarration(); wait 1
	Quit();
}

// Win instructions
when succeeded WalkTo(Player, Cottage.Door) {
	SetNarration('Come back after you have found the Guard, the Merchant, the Bandit, and the Chest.')
	ShowNarration();
}

when input Key Cancel {
	HideNarration();
	EnableInput();
}

// Must talk to Grandma before leaving home
when input Open door[0] & $metGrandma[0] = false {
	SetNarration('You should talk to Grandma before you leave');
	ShowNarration();
}

// Doors
when input Open door[0] {
	WalkTo(Player, door[0]);
}

when succeeded WalkTo(Player, door[0]){
	Exit(Player, door[0], true);
}

when succeeded Exit(Player, door[0], true){
	SetPosition(Player, door[1]);
	FadeIn();
	EnableInput();
}

when failed Exit(Player, door[0], true) {
	SetPosition(Player, door[0]);
	EnableInput();
}

// Transitions
when input arrived Player position transition[0] & $transitioning[0] = false {
	$transitioning[0] = true;
	Exit(Player, transition[0], true);
}

when succeeded Exit(Player, transition[0], true) {
	Enter(Player, transition[1], true); wait succeeded
	$transitioning[0] = false;
	EnableInput();
}

when failed Exit(Player, transition[0], true) {
	SetPosition(Player, transition[0]); wait succeeded
	FadeIn();
	EnableInput();
}

when input Selected OkGrandma {
	HideDialog();
	$metGrandma[0] = true;
}

when input Selected OkGuard {
	HideDialog();
	$metGuard[0] = true;
}

when input Selected OkMerchant {
	HideDialog();
	$metMerchant[0] = true;
}

when input Selected OkBandit {
	HideDialog();
	$metBandit[0] = true;
}

when input Selected OkChest {
	HideDialog();
	$metChest[0] = true;
}


